<?php
# ***** BEGIN LICENSE BLOCK *****
# This file is part of DotClear.
# Copyright (c) 2006 Olivier Meunier and contributors. All rights
# reserved.
#
# DotClear is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# DotClear is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with DotClear; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# ***** END LICENSE BLOCK *****

$core->url->register('random_post','','^random$',array('randomPost','getRandomPostURL'));
$core->tpl->addValue('RandomPostURL',array('randomPost','tplRandomPostURL'));

class randomPost {
	public static function getRandomPostURL($args)
	{
		global $core;

		// Get the total number of public posts in the blog
		$count = $core->blog->getPosts(null, true);
		// Get a random number between 0 and the total number of posts minus 1
		// This gives us an offset to access a random record in the next query
		$offset = rand(0, $count->f(0) - 1);

		// Get the random post, via an SQL request of type '... limit 1 offset XXX'
		$randomPost = $core->blog->getPosts(array('limit'=>array($offset, 1), 'no_content'=>'1'));

		// Get the URL of the post, and redirect to it
		$url = $randomPost->getURL();
		http::head(302,'Found');
		header('Location: '.$url);
		exit;
	}

	public static function tplRandomPostURL($attr)
	{
		$f = $GLOBALS['core']->tpl->getFilters($attr);
		return '<?php echo '.sprintf($f,'$core->blog->url.$core->url->getBase("")."random"').'; ?>';
	}

	public static function randomPostWidget(&$w)
	{
		global $core;

		$title = $w->title ? html::escapeHTML($w->title) : __('Random post');
		return '<div id="randompost"><ul><li><a href="'.$core->blog->url.$core->url->getBase('').'random">'.$title.'</a></li></ul></div>';
	}
}
?>
